﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Data;
using System.Data.SqlClient;
using System.Web.Configuration;
using Syncfusion.JavaScript.Shared.Serializer;

namespace WebApplication2.Controllers

{    
    public class GanttController : Controller
    {
        // GET: TreeGrid
        public ActionResult Index()
        {      
           
            return View();
        }      
     

        [HttpGet]
        public ActionResult _Gantt()
        {
             var DataSource = ResourceDataSource.GetData();
            ViewBag.datasource = DataSource;
            var Resources = ResourceList.GetData();
            ViewBag.resources = Resources;                   
           return PartialView("Gantt", DataSource);
           
        }
        }
    public class ResourceList
        {
            public static List<ResourceListData> GetData()
            {
                List<ResourceListData> list=new List<ResourceListData>();

                list.Add(new ResourceListData() { Id = 1, Name = "Resource1" });
                list.Add(new ResourceListData() { Id = 2, Name = "Resource2" });
                list.Add(new ResourceListData() { Id = 3, Name = "Resource3" });
                list.Add(new ResourceListData() { Id = 4, Name = "Resource4" });
                list.Add(new ResourceListData() { Id = 5, Name = "Resource5" });
                list.Add(new ResourceListData() { Id = 6, Name = "Resource6" });
                list.Add(new ResourceListData() { Id = 7, Name = "Resource7" });
                return list;
            }
        }

        public class ResourceListData
        {
            public int Id { get; set; }
            public string Name { get; set; }
        }

        public class ResourceDataSource
        {

            public static List<ResourceData> GetData()
            {
                List<ResourceData> list = new List<ResourceData>();
                list.Add(new ResourceData()
                {
                    Id = 1,
                    Name = "Task 1",
                    StartDate = "10/23/2013",
                    BaselineStartDate = "10/23/2013",
                    BaselineEndDate = "10/28/2013",
                    Duration = 10,
                    PercentDone = 70,
                    Resources =new List<int>(){1,2,4,5},

                    Children = (new List<ResourceData>()
                    {
                        new ResourceData()
                        {
                            Id = 2,
                            Name = "Child task 1",
                            StartDate = "10/23/2013",
                            BaselineStartDate = "10/23/2013",
                            BaselineEndDate = "10/26/2013",
                            Duration = 4,
                            PercentDone = 80,
                            Resources =new List<int>(){ 2,4},
                        },
                        new ResourceData()
                        {
                            Id = 3,
                            Name = "Child Task 2",
                            StartDate = "10/24/2013",
                            BaselineStartDate = "10/24/2013",
                            BaselineEndDate = "10/28/2013",
                            Duration = 5,
                            PercentDone = 65,
                            Predecessor = "2",
                            Resources =new List<int>(){1},
                        },
                        new ResourceData()
                        {
                            Id = 4,
                            Name = "Child task 3",
                            StartDate = "10/25/2013",
                            BaselineStartDate = "10/26/2013",
                            BaselineEndDate = "10/28/2013",
                            Duration = 6,
                            PercentDone = 77,
                            Resources =new List<int>(){5},
                            Children = (new List<ResourceData>()
                            {
                                new ResourceData()
                                {
                                    Id = 5,
                                    Name = "Grand child task 1",
                                    StartDate = "10/28/2013",
                                    BaselineStartDate = "10/27/2013",
                                    BaselineEndDate = "11/1/2013",
                                    Duration = 5,
                                    PercentDone = 60,
                                    Resources =new List<int>(){1,3,7},
                                },
                                new ResourceData()
                                {
                                    Id = 6,
                                    Name = "Grand child task 2",
                                    StartDate = "10/29/2013",
                                    BaselineStartDate = "10/29/2013",
                                    BaselineEndDate = "10/31/2013",
                                    Duration = 6,
                                    PercentDone = 77,
                                    Predecessor = "5",
                                    Resources =new List<int>(){7},
                                },
                                new ResourceData()
                                {
                                    Id = 7,
                                    Name = "Grand child task 3",
                                    StartDate = new System.DateTime(2013, 10, 23),
                                    BaselineStartDate = "10/25/2013",
                                    BaselineEndDate = "10/25/2013",
                                    Duration = 0,
                                    PercentDone = 0,
                                    Predecessor = "6"

                                }
                            })
                        }
                    })

                });




                return list;
            }
        }

        public class ResourceData
        {
            public object StartDate { get; set; }
            public int Id { get; set; }
            public string Name { get; set; }
            public int Duration { get; set; }
            public int PercentDone { get; set; }
            public List<ResourceData> Children { get; set; }
            public string Predecessor { get; set; }
            public string BaselineStartDate { get; set; }
            public string BaselineEndDate { get; set; }
            public List<int> Resources { get; set; }

        }
    }
